Bug 609612 - nss : does not adhere to Static Library Packaging Guidelines
Summary: nss : does not adhere to Static Library Packaging Guidelines
Keywords:
Status: CLOSED ERRATA
Alias: None
Product: Fedora
Classification: Fedora
Component: nss
Version: rawhide
Hardware: All
OS: Linux
low
low
Target Milestone: ---
Assignee: Elio Maldonado Batiz
QA Contact: Fedora Extras Quality Assurance
URL:
Whiteboard:
Depends On:
Blocks:
TreeView+ depends on / blocked
 
Reported: 2010-06-30 16:58 UTC by Michael Schwendt
Modified: 2011-08-05 23:57 UTC (History)
4 users (show)

Fixed In Version: nss-3.12.10-5.fc15
Doc Type: Bug Fix
Doc Text:
Clone Of:
Environment:
Last Closed: 2011-06-28 12:48:24 UTC


Attachments (Terms of Use)

Description Michael Schwendt 2010-06-30 16:58:35 UTC
https://fedoraproject.org/wiki/Packaging:Guidelines#Packaging_Static_Libraries_2

Build: nss-3.12.6-8.fc14.src.rpm

nss-devel
    contains only static libraries,
    but no virtual -static package is provided

nss-pkcs11-devel
    contains only static libraries,
    but no virtual -static package is provided

Comment 1 Elio Maldonado Batiz 2010-06-30 18:16:19 UTC
The static libraries in question are in
%files devel
%defattr(-,root,root)
%{_libdir}/libcrmf.a
....
   and in
files pkcs11-devel
%defattr(-, root, root)
..... headers ....
%{_libdir}/libnssb.a
%{_libdir}/libnssckfw.a

Bob or Kai, could you educate me on the reason for the static libraries? Thanks.

Comment 2 Bob Relyea 2010-06-30 21:47:29 UTC
libcrmf.a is only used by the browser to create CRMF messages for key gen. The code really needs to be cleaned up and turned into a real library.

You have to work to get it (it doesn't show up in a normal NSS link line). nss-devel should not be -static and it provides access to the normal nss dynamic libraries.

libnssb and libnssckfw are for used to implement PKCS #11 modules. I think that all the libraries in pkcs11-devel are static, so it should be OK to call it nss-pkcs11-devel-static.

Comment 3 Michael Schwendt 2010-07-01 08:21:24 UTC
It's not necessary to rename packages. 

nss-pkcs11-devel should just add a versioned Provides for a virtual "nss-pkcs11-static" package, as it includes two static libraries only. It requires nss-devel, which pulls in different shared libs, but everything which needs the static libs in nss-pkcs11-devel would need to BuildRequires nss-pkcs11-static.

nss-devel is similar. Its libcrmf.a is misplaced, as it isn't stored in a separate "nss-static" package, and there is no nss-static Provides either. What makes this further convoluted, nss-devel's .so library files are the same as the run-time library files, which is the reason why nss-devel itself doesn't contain any shared libs but just the single static lib.

Comment 4 Bug Zapper 2010-07-30 12:20:16 UTC
This bug appears to have been reported against 'rawhide' during the Fedora 14 development cycle.
Changing version to '14'.

More information and reason for this action is here:
http://fedoraproject.org/wiki/BugZappers/HouseKeeping

Comment 5 Fedora Admin XMLRPC Client 2010-09-07 20:53:56 UTC
This package has changed ownership in the Fedora Package Database.  Reassigning to the new owner of this component.

Comment 6 Fedora Update System 2010-09-30 00:25:39 UTC
nss-3.12.7-8.fc14,nss-softokn-3.12.7-7.fc14 has been submitted as an update for Fedora 14.
https://admin.fedoraproject.org/updates/nss-3.12.7-8.fc14,nss-softokn-3.12.7-7.fc14

Comment 7 Fedora Update System 2010-09-30 00:29:38 UTC
nss-3.12.7-8.fc13,nss-softokn-3.12.7-7.fc13 has been submitted as an update for Fedora 13.
https://admin.fedoraproject.org/updates/nss-3.12.7-8.fc13,nss-softokn-3.12.7-7.fc13

Comment 8 Fedora Update System 2010-09-30 05:31:25 UTC
nss-3.12.7-8.fc14, nss-softokn-3.12.7-7.fc14 has been pushed to the Fedora 14 testing repository.  If problems still persist, please make note of it in this bug report.
 If you want to test the update, you can install it with 
 su -c 'yum --enablerepo=updates-testing update nss nss-softokn'.  You can provide feedback for this update here: https://admin.fedoraproject.org/updates/nss-3.12.7-8.fc14,nss-softokn-3.12.7-7.fc14

Comment 9 Michael Schwendt 2010-10-05 13:45:25 UTC
Build: nss-3.12.8-3.fc15.src.rpm

nss-devel
    contains only static libraries,
    but no virtual -static package is provided

Comment 10 Fedora Update System 2010-10-07 18:19:30 UTC
nss-3.12.8-2.fc14,nss-softokn-3.12.8-1.fc14,nss-util-3.12.8-1.fc14 has been submitted as an update for Fedora 14.
https://admin.fedoraproject.org/updates/nss-3.12.8-2.fc14,nss-softokn-3.12.8-1.fc14,nss-util-3.12.8-1.fc14

Comment 11 Fedora Update System 2010-10-07 19:54:57 UTC
nss-3.12.8-2.fc14, nss-softokn-3.12.8-1.fc14, nss-util-3.12.8-1.fc14 has been pushed to the Fedora 14 testing repository.  If problems still persist, please make note of it in this bug report.
 If you want to test the update, you can install it with 
 su -c 'yum --enablerepo=updates-testing update nss nss-softokn nss-util'.  You can provide feedback for this update here: https://admin.fedoraproject.org/updates/nss-3.12.8-2.fc14,nss-softokn-3.12.8-1.fc14,nss-util-3.12.8-1.fc14

Comment 12 Fedora Update System 2010-10-08 00:07:51 UTC
nss-util-3.12.8-1.fc12,nss-softokn-3.12.8-1.fc12,nss-3.12.8-2.fc12 has been submitted as an update for Fedora 12.
https://admin.fedoraproject.org/updates/nss-util-3.12.8-1.fc12,nss-softokn-3.12.8-1.fc12,nss-3.12.8-2.fc12

Comment 13 Michael Schwendt 2011-03-16 20:45:24 UTC
https://fedoraproject.org/wiki/Packaging:Guidelines#Packaging_Static_Libraries_2

Build: nss-3.12.9-13.fc16.src.rpm

nss-devel
    contains only static libraries,
    but no virtual -static package is provided

Comment 14 Michael Schwendt 2011-06-28 12:48:24 UTC
Closed by: fedora-report-static-batch.py
http://mschwendt.fedorapeople.org/staticbugstat.html

Comment 15 Fedora Update System 2011-07-22 17:34:32 UTC
nss-3.12.10-5.fc15 has been submitted as an update for Fedora 15.
https://admin.fedoraproject.org/updates/nss-3.12.10-5.fc15

Comment 16 Fedora Update System 2011-08-05 23:56:47 UTC
nss-3.12.10-5.fc15 has been pushed to the Fedora 15 stable repository.  If problems still persist, please make note of it in this bug report.


Note You need to log in before you can comment on or make changes to this bug.